-- Code from Section 12.6

module Unparsing where
import PhantomTypes

data Dir th ro
 =                  Lit    (th           :=: ro) String 
 |                  Int    ((Int->th)    :=: ro)
 |                  String ((String->th) :=: ro)
 | forall ro1 ro2 . Cat    (ro2          :=: ro) (Dir ro1 ro2) (Dir th ro1)

infixr 5 |^|
lit = Lit refl
int = Int refl
string = String refl
(|^|) = Cat refl

format' :: forall th ro . Dir th ro -> (String -> th) -> (String -> ro)
format' (Lit p s)     = \cont out -> from p $ cont (out ++ s)
format' (Int p)       = \cont out -> from p $ \i -> cont (out ++ show i)
format' (String p)    = \cont out -> from p $ \s -> cont (out ++ s)
format' (Cat p d1 d2) = \cont out -> from p $ format' d1 (format' d2 cont) out

format :: forall ro . Dir String ro -> ro
format d = format' d id ""